{$mode objfpc}{$h+}{$r+}
uses
  SysUtils;

procedure Ex(code: Integer; msg: String; p: array of const);
begin
  Write(Format(msg, p));
  Halt(code);
end;

function Reverse(x: Integer): Integer;
begin
  Result := 0;
  while x > 0 do begin
    Result := Result * 10 + x mod 10;
    x := x div 10;
  end;
end;

var
  fin, fout, fans: TextFile;
  sout: String;
  i, x, y: Integer;
begin
  AssignFile(fin, ParamStr(1)); Reset(fin);
  AssignFile(fans, ParamStr(3)); Reset(fans);
  try
    AssignFile(fout, ParamStr(2)); Reset(fout);
    Read(fin, x, y);
  except on E: Exception do
    Ex(3, E.Message, []);
  end;
  Readln(fout, sout);

  for i := 1 to Length(sout) do
    if not (sout[i] in ['I', 'R']) then
      Ex(2, 'Bad command %s', [sout[i]]);

  if Length(sout) > 200000 then Ex(1, 'Too long: %d', [Length(sout)]);

  for i := 1 to Length(sout) do
    case sout[i] of
    'I': x += 1;
    'R': x := Reverse(x);
    end;
  if x <> y then
    Ex(1, '%d instead of %d', [x, y]);
  Ex(0, 'ok', []);
end.
